package lawOfDemeter;

/**
 * @author Pengcheng Wu
 */

import org.aspectj.lang.*;

class Any {
    pointcut scope():
      !within(lawOfDemeter..*); // not in this package

    pointcut Call():
      scope() && call(* *(..)); // any call
                                // including constructor calls? - no

    pointcut ConstructorCall():
      scope() && call(*.new (..)); // any constructor

    pointcut StaticInit():
      scope() && staticinitialization(*);

  // CORRECTED CODE - the Execution pointcut did not include constructor executions
    pointcut Execution():
      scope() && (execution(* *(..)) || ConstructorExecution()); // any execution
//      scope() && execution(* *(..)); // any execution

    pointcut ConstructorExecution():
      scope() && execution(*.new(..));
  // END CORRECTED CODE

};


